local ffi = require 'ffi'
local lj_include = require 'lj_include'

lj_include('bits_sigset')

ffi.cdef[[
typedef __sigset_t sigset_t;
]]

lj_include('time')
lj_include('bits_time')

ffi.cdef[[
typedef long int __fd_mask;
typedef struct {
    __fd_mask fds_bits[1024 / (8 * (int) sizeof(__fd_mask))];
}
fd_set;
typedef __fd_mask fd_mask;
int select(int __nfds, fd_set * __readfds,
    fd_set * __writefds, fd_set * __exceptfds, struct timeval *__timeout);
int pselect(int __nfds, fd_set * __readfds,
    fd_set * __writefds,
    fd_set * __exceptfds,
    const struct timespec *__timeout, const __sigset_t * __sigmask);
]]

local defs = {
}
local format, cdef, C = string.format, ffi.cdef, ffi.C
for sym, val in pairs(defs) do
    if not pcall(function() return C[sym] end) then
        cdef(format("enum {%s = %s};", sym, val))
    end
end

