local xpath = require 'xpath'
local lom = require 'lxp.lom'

local m = {}

function unzip(filename)
    os.execute("mkdir /tmp/xlsx")
    os.execute("unzip " .. filename .. " -d /tmp/xlsx")
    return
end

function removeFiles()
    os.execute("rm -r /tmp/xlsx")  
    return
end

function acquireStrings()
    local file = assert(io.open("/tmp/xlsx/xl/sharedStrings.xml", "r"))
    local text = file:read("*all")
    file:close()
    return xpath.selectNodes(lom.parse(text), '/sst/si/text()')
end

function findWorksheets()
    local worksheetNames = {}
    local handle = io.popen("ls /tmp/xlsx/xl/worksheets/")
    if handle then
        for line in handle:lines() do
            if  line ~= "_rels" then
                table.insert(worksheetNames, line)
            end
        end
    end
    handle:close()
    return worksheetNames
end

function openWorksheet(filename)
    local file = assert(io.open("/tmp/xlsx/xl/worksheets/" .. filename, "r"))
    local text = file:read("*all")
    file:close()
    return text
end

function charToNum(char)
    local num
    char = string.lower(char)
    num = string.byte(char)
    num = num  - 96 --converts to ascii and then integer
    return num
end

function alphabeticToNumeric(alpha)
    local length = string.len(alpha)
    local number = 0
    local i = 1
    for char in string.gmatch(alpha, ".") do
        local charNum = charToNum(char)
        number = number + charNum * 26^(length - i) --base 26 -> base 10
        i = i + 1
    end
    return number
end

function readWorksheet(file, strings)
    local text = xpath.selectNodes(lom.parse(file),'/worksheet/sheetData/row/')
    local category, columnNum, rowNum   
    local sheet = {}
    for k,v in pairs(text) do
        local row = {}
        for k2,v2 in pairs(v) do 
            if v2.attr and v2[1] then
                category = v2.attr.t
                columnNum, rowNum = string.match(v2.attr.r, "(%a+)(%d+)")
                rowNum = tonumber(rowNum)
                columnNum = alphabeticToNumeric(columnNum)
                print(rowNum, columnNum)
                local cell
                local value = tonumber(v2[1][1])
                if category == "s" then --cell contains string
                    local index = value + 1 -- 1 vs 0 indexing
                    cell = strings[index][1]
                elseif category == "b" then --cell contains binary
                    if value == 1 then
                        cell = true
                    else
                        cell = false
                    end
                else -- cell contains number
                    cell =  value
                end
                print(cell)
                row[columnNum] = cell --insert cell into column
--            elseif not v2[1] then 
            else 
--                break
            end
        end
--        if #row ~=0 then
            print("writing row# " .. rowNum)
            sheet[rowNum] = row
--        else
--            print("rowNum = 0")
--        end
    end
	return sheet
end

function openWorkbook(workbook)
    local workSheets = {}
    local strings = acquireStrings()
    local sheetNames = findWorksheets()
    for k,v in pairs(sheetNames) do
        local xml = openWorksheet(v)
        local worksheet = readWorksheet(xml, strings)
        --workSheets[v] = worksheet
        table.insert(workSheets, worksheet)
    end
    return workSheets    
end

function m.open(filename)
    local workbook = {}
    unzip(filename)
    workbook = openWorkbook()    
    removeFiles()
    return workbook
end

return m
